function out = PredatorPreyModel
out{1} = [];
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = @der3;
out{8} = @der4;
out{9} = @der5;

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,par_a,par_b,par_d,par_epsil)
dydt=[par_a*kmrgd(1)*(1-kmrgd(1))-par_b*kmrgd(1)*kmrgd(2)/(1+par_epsil*kmrgd(1));
par_d*kmrgd(1)*kmrgd(2)/(1+par_epsil*kmrgd(1));];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,par_a,par_b,par_d,par_epsil)
jac=[ (kmrgd(1)*kmrgd(2)*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - par_a*(kmrgd(1) - 1) - (kmrgd(2)*par_b)/(kmrgd(1)*par_epsil + 1) - kmrgd(1)*par_a , -(kmrgd(1)*par_b)/(kmrgd(1)*par_epsil + 1) ; (kmrgd(2)*par_d)/(kmrgd(1)*par_epsil + 1) - (kmrgd(1)*kmrgd(2)*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 , (kmrgd(1)*par_d)/(kmrgd(1)*par_epsil + 1) ];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,par_a,par_b,par_d,par_epsil)
jacp=[ -kmrgd(1)*(kmrgd(1) - 1) , -(kmrgd(1)*kmrgd(2))/(kmrgd(1)*par_epsil + 1) , 0 , (kmrgd(1)^2*kmrgd(2)*par_b)/(kmrgd(1)*par_epsil + 1)^2 ; 0 , 0 , (kmrgd(1)*kmrgd(2))/(kmrgd(1)*par_epsil + 1) , -(kmrgd(1)^2*kmrgd(2)*par_d)/(kmrgd(1)*par_epsil + 1)^2 ];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,par_a,par_b,par_d,par_epsil)
hess1=[ (2*kmrgd(2)*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - 2*par_a - (2*kmrgd(1)*kmrgd(2)*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , (kmrgd(1)*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - par_b/(kmrgd(1)*par_epsil + 1) ; (2*kmrgd(1)*kmrgd(2)*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (2*kmrgd(2)*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 , par_d/(kmrgd(1)*par_epsil + 1) - (kmrgd(1)*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 ];
hess2=[ (kmrgd(1)*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - par_b/(kmrgd(1)*par_epsil + 1) , 0 ; par_d/(kmrgd(1)*par_epsil + 1) - (kmrgd(1)*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 , 0 ];
hess(:,:,1) =hess1;
hess(:,:,2) =hess2;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,par_a,par_b,par_d,par_epsil)
hessp1=[ 1 - 2*kmrgd(1) , 0 ; 0 , 0 ];
hessp2=[ (kmrgd(1)*kmrgd(2)*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - kmrgd(2)/(kmrgd(1)*par_epsil + 1) , -kmrgd(1)/(kmrgd(1)*par_epsil + 1) ; 0 , 0 ];
hessp3=[ 0 , 0 ; kmrgd(2)/(kmrgd(1)*par_epsil + 1) - (kmrgd(1)*kmrgd(2)*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 , kmrgd(1)/(kmrgd(1)*par_epsil + 1) ];
hessp4=[ (2*kmrgd(1)*kmrgd(2)*par_b)/(kmrgd(1)*par_epsil + 1)^2 - (2*kmrgd(1)^2*kmrgd(2)*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^3 , (kmrgd(1)^2*par_b)/(kmrgd(1)*par_epsil + 1)^2 ; (2*kmrgd(1)^2*kmrgd(2)*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^3 - (2*kmrgd(1)*kmrgd(2)*par_d)/(kmrgd(1)*par_epsil + 1)^2 , -(kmrgd(1)^2*par_d)/(kmrgd(1)*par_epsil + 1)^2 ];
hessp(:,:,1) =hessp1;
hessp(:,:,2) =hessp2;
hessp(:,:,3) =hessp3;
hessp(:,:,4) =hessp4;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,par_a,par_b,par_d,par_epsil)
tens31=[ (6*kmrgd(1)*kmrgd(2)*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (6*kmrgd(2)*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , (2*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - (2*kmrgd(1)*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 ; (6*kmrgd(2)*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (6*kmrgd(1)*kmrgd(2)*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , (2*kmrgd(1)*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (2*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 ];
tens32=[ (2*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - (2*kmrgd(1)*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , 0 ; (2*kmrgd(1)*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (2*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 , 0 ];
tens33=[ (2*par_b*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 - (2*kmrgd(1)*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , 0 ; (2*kmrgd(1)*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (2*par_d*par_epsil)/(kmrgd(1)*par_epsil + 1)^2 , 0 ];
tens34=[ 0 , 0 ; 0 , 0 ];
tens3(:,:,1,1) =tens31;
tens3(:,:,1,2) =tens32;
tens3(:,:,2,1) =tens33;
tens3(:,:,2,2) =tens34;
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,par_a,par_b,par_d,par_epsil)
tens41=[ (24*kmrgd(2)*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (24*kmrgd(1)*kmrgd(2)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 , (6*kmrgd(1)*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (6*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 ; (24*kmrgd(1)*kmrgd(2)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (24*kmrgd(2)*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , (6*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (6*kmrgd(1)*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 ];
tens42=[ (6*kmrgd(1)*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (6*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , 0 ; (6*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (6*kmrgd(1)*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens43=[ (6*kmrgd(1)*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (6*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , 0 ; (6*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (6*kmrgd(1)*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens44=[ 0 , 0 ; 0 , 0 ];
tens45=[ (6*kmrgd(1)*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (6*par_b*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 , 0 ; (6*par_d*par_epsil^2)/(kmrgd(1)*par_epsil + 1)^3 - (6*kmrgd(1)*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens46=[ 0 , 0 ; 0 , 0 ];
tens47=[ 0 , 0 ; 0 , 0 ];
tens48=[ 0 , 0 ; 0 , 0 ];
tens4(:,:,1,1,1) =tens41;
tens4(:,:,1,1,2) =tens42;
tens4(:,:,1,2,1) =tens43;
tens4(:,:,1,2,2) =tens44;
tens4(:,:,2,1,1) =tens45;
tens4(:,:,2,1,2) =tens46;
tens4(:,:,2,2,1) =tens47;
tens4(:,:,2,2,2) =tens48;
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,par_a,par_b,par_d,par_epsil)
tens51=[ (120*kmrgd(1)*kmrgd(2)*par_b*par_epsil^5)/(kmrgd(1)*par_epsil + 1)^6 - (120*kmrgd(2)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 , (24*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (24*kmrgd(1)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 ; (120*kmrgd(2)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (120*kmrgd(1)*kmrgd(2)*par_d*par_epsil^5)/(kmrgd(1)*par_epsil + 1)^6 , (24*kmrgd(1)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (24*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 ];
tens52=[ (24*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (24*kmrgd(1)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 , 0 ; (24*kmrgd(1)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (24*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens53=[ (24*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (24*kmrgd(1)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 , 0 ; (24*kmrgd(1)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (24*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens54=[ 0 , 0 ; 0 , 0 ];
tens55=[ (24*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (24*kmrgd(1)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 , 0 ; (24*kmrgd(1)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (24*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens56=[ 0 , 0 ; 0 , 0 ];
tens57=[ 0 , 0 ; 0 , 0 ];
tens58=[ 0 , 0 ; 0 , 0 ];
tens59=[ (24*par_b*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 - (24*kmrgd(1)*par_b*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 , 0 ; (24*kmrgd(1)*par_d*par_epsil^4)/(kmrgd(1)*par_epsil + 1)^5 - (24*par_d*par_epsil^3)/(kmrgd(1)*par_epsil + 1)^4 , 0 ];
tens510=[ 0 , 0 ; 0 , 0 ];
tens511=[ 0 , 0 ; 0 , 0 ];
tens512=[ 0 , 0 ; 0 , 0 ];
tens513=[ 0 , 0 ; 0 , 0 ];
tens514=[ 0 , 0 ; 0 , 0 ];
tens515=[ 0 , 0 ; 0 , 0 ];
tens516=[ 0 , 0 ; 0 , 0 ];
tens5(:,:,1,1,1,1) =tens51;
tens5(:,:,1,1,1,2) =tens52;
tens5(:,:,1,1,2,1) =tens53;
tens5(:,:,1,1,2,2) =tens54;
tens5(:,:,1,2,1,1) =tens55;
tens5(:,:,1,2,1,2) =tens56;
tens5(:,:,1,2,2,1) =tens57;
tens5(:,:,1,2,2,2) =tens58;
tens5(:,:,2,1,1,1) =tens59;
tens5(:,:,2,1,1,2) =tens510;
tens5(:,:,2,1,2,1) =tens511;
tens5(:,:,2,1,2,2) =tens512;
tens5(:,:,2,2,1,1) =tens513;
tens5(:,:,2,2,1,2) =tens514;
tens5(:,:,2,2,2,1) =tens515;
tens5(:,:,2,2,2,2) =tens516;
